using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.BizTalk.BaseFunctoids;
using System.Reflection;

namespace FunctoidDemo
{
    public class FormattedDate : BaseFunctoid
    {
        public FormattedDate()
        {
            this.ID = 9500;
            //Specify the resource assembly name from which some settings are retrieved.
            this.SetupResourceAssembly("FunctoidDemo.Properties.Resources", Assembly.GetExecutingAssembly());

            // Get settings from resource by given keys.
            this.SetTooltip("IDS_FORMATTEDDATEFUNCTOID_TOOLTIP");
            this.SetBitmap("IDI_FORMATTEDDATE_ICON");
            this.SetName("IDS_FORMATTEDDATEFUNCTOID_NAME");
            this.SetDescription("IDS_FORMATTEDDATEFUNCTOID_DESCRIPTION");
            this.SetMinParams(0);
            this.SetMaxParams(1);

            // this method call lets the mapper what function to call, when functoid
            // is deployed to GAC, ConvertCurrencyField is the method we'll include later.
            this.SetExternalFunctionName(GetType().Assembly.FullName, "FunctoidDemo.FormattedDate", "GetCurrentDateTime");
            base.SetScriptBuffer(ScriptType.CSharp, this.GetCSharpBuffer());
            // defining category in toolbox, 
            //this decides under which category the functoid will be added.
            this.Category = FunctoidCategory.DateTime;

            //define output and input connection types..
            this.OutputConnectionType = ConnectionType.AllExceptRecord;
            this.AddInputConnectionType(ConnectionType.AllExceptRecord);

        }
        //This function is to return current date time with given format.
        private string GetCSharpBuffer()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("public string GetCurrentDateTime( string format)\n");
            builder.Append("{\n");
            builder.Append("\treturn DateTime.Now.ToString(format);\n");
            builder.Append("}");
            return builder.ToString();
        }

    }
}
